<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema">
	<xsl:template match="/">
		<!--		<html>
			<head/>
			<body>
-->
		<xsl:for-each select="QdmProject">
,,,,,,,,,,,,,,,Payitem,<xsl:for-each select="Payitem">
				<xsl:text>"</xsl:text>
				<xsl:call-template name="duplicate-the-double-quotes">
					<xsl:with-param name="text" select="Name"/>
				</xsl:call-template>
				<xsl:text>",</xsl:text>
			</xsl:for-each>,
,,,,,,,,,,,,,,,Description,<xsl:for-each select="Payitem">
				<xsl:text>"</xsl:text>
				<xsl:call-template name="duplicate-the-double-quotes">
					<xsl:with-param name="text" select="Description"/>
				</xsl:call-template>
				<xsl:text>",</xsl:text>
			</xsl:for-each>,
,,,,,,,,,,,,,,,Unit,<xsl:for-each select="Payitem">
				<xsl:value-of select="Unit"/>,</xsl:for-each>,
Chain,Minimum Absolute Station,Minimum Station,Minimum Region,Minimum Formatted Station,Maximum Absolute Station,Maximum Station,Maximum Region,Maximum Formatted Station,Minimum Offset,Maximum Offset,Run,Remarks,Description,Extended Description,Phase,<xsl:for-each select="Payitem">
				<xsl:value-of select="@phase"/>,</xsl:for-each>,
<xsl:for-each select="Chains">
				<xsl:for-each select="Chain/Name">
					<xsl:variable name="chain">
						<xsl:value-of select="."/>
					</xsl:variable>
					<xsl:for-each select="../../../Payitem">
						<xsl:variable name="payitemName1">
							<xsl:value-of select="Name"/>
						</xsl:variable>
						<xsl:variable name="phase1">
							<xsl:value-of select="@phase"/>
						</xsl:variable>
						<xsl:for-each select="Quantity">
							<xsl:sort select="MinimumStation/AbsoluteStation" data-type="number"/>
							<xsl:variable name="thisChain">
								<xsl:value-of select="Chain"/>
							</xsl:variable>
							<xsl:if test="$thisChain=$chain">
								<xsl:variable name="quantityNetValue">
									<xsl:value-of select="format-number(NetValue,'0.00')"/>
								</xsl:variable>
								<xsl:for-each select="MinimumStation">
									<xsl:for-each select="AbsoluteStation">
										<xsl:value-of select="$chain"/>,<xsl:value-of select="format-number(../AbsoluteStation,'#0.00')"/>,<xsl:value-of select="format-number(../Station,'#0.00')"/>,<xsl:value-of select="../Region"/>,<xsl:value-of select="../FormattedStation"/>,<xsl:value-of select="format-number (../../MaximumStation/AbsoluteStation,'#0.00')"/>,<xsl:value-of select="format-number(../../MaximumStation/Station,'#0.00')"/>,<xsl:value-of select="../../MaximumStation/Region"/>,<xsl:value-of select="../../MaximumStation/FormattedStation"/>,<xsl:value-of select="../../MinimumStation/Offset"/>,<xsl:value-of select="../../MaximumStation/Offset"/>
										<xsl:text>,"</xsl:text>
										<xsl:call-template name="duplicate-the-double-quotes">
											<xsl:with-param name="text" select="../../RunName"/>
										</xsl:call-template>
										<xsl:text>","</xsl:text>
										<xsl:call-template name="duplicate-the-double-quotes">
											<xsl:with-param name="text" select="../../Remarks"/>
										</xsl:call-template>
										<xsl:text>","</xsl:text>
										<xsl:call-template name="duplicate-the-double-quotes">
											<xsl:with-param name="text" select="../../Description"/>
										</xsl:call-template>
										<xsl:text>","</xsl:text>
										<xsl:call-template name="duplicate-the-double-quotes">
											<xsl:with-param name="text" select="../../ExtendedDescription"/>
										</xsl:call-template>
										<xsl:text>",,</xsl:text>
										<xsl:for-each select="/QdmProject/Payitem">
											<xsl:variable name="payitemName2">
												<xsl:value-of select="Name"/>
											</xsl:variable>
											<xsl:variable name="phase2">
												<xsl:value-of select="@phase"/>
											</xsl:variable>
											<xsl:if test="$payitemName1=$payitemName2 and $phase1=$phase2">
												<xsl:value-of select="$quantityNetValue"/>
											</xsl:if>,</xsl:for-each>,
</xsl:for-each>
								</xsl:for-each>
							</xsl:if>
						</xsl:for-each>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:for-each>
			<xsl:for-each select="Payitem">
				<xsl:variable name="payitemName1">
					<xsl:value-of select="Name"/>
				</xsl:variable>
				<xsl:variable name="phase1">
					<xsl:value-of select="@phase"/>
				</xsl:variable>
				<xsl:for-each select="Quantity[count(Chain)=0]">
					<xsl:variable name="quantityNetValue">
						<xsl:value-of select="format-number(NetValue,'0.00')"/>
					</xsl:variable>
					<xsl:text>,,,,,,,,,,,"</xsl:text>
					<xsl:call-template name="duplicate-the-double-quotes">
						<xsl:with-param name="text" select="RunName"/>
					</xsl:call-template>
					<xsl:text>","</xsl:text>
					<xsl:call-template name="duplicate-the-double-quotes">
						<xsl:with-param name="text" select="Remarks"/>
					</xsl:call-template>
					<xsl:text>","</xsl:text>
					<xsl:call-template name="duplicate-the-double-quotes">
						<xsl:with-param name="text" select="Description"/>
					</xsl:call-template>
					<xsl:text>","</xsl:text>
					<xsl:call-template name="duplicate-the-double-quotes">
						<xsl:with-param name="text" select="ExtendedDescription"/>
					</xsl:call-template>
					<xsl:text>",,</xsl:text>
					<xsl:for-each select="/QdmProject/Payitem">
						<xsl:variable name="payitemName2">
							<xsl:value-of select="Name"/>
						</xsl:variable>
						<xsl:variable name="phase2">
							<xsl:value-of select="@phase"/>
						</xsl:variable>
						<xsl:if test="$payitemName1=$payitemName2 and $phase1=$phase2">
							<xsl:value-of select="$quantityNetValue"/>
						</xsl:if>,</xsl:for-each>,
</xsl:for-each>
			</xsl:for-each>
		</xsl:for-each>
		<!--			</body>
		</html>
-->
	</xsl:template>
	<!--template to replace the double quotes with two double quotes. -->
	<xsl:template name="duplicate-the-double-quotes">
		<xsl:param name="text"/>
		<xsl:variable name="replace">"</xsl:variable>
		<xsl:choose>
			<xsl:when test="contains($text, $replace)">
				<xsl:value-of select="substring-before($text, $replace)"/>
				<xsl:text disable-output-escaping="no">""</xsl:text>
				<xsl:call-template name="duplicate-the-double-quotes">
					<xsl:with-param name="text" select="substring-after($text, $replace)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
