<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema">
<xsl:key name="payitem-name-key" match="Payitem" use="Name"/>

	<xsl:template match="/">
		<!--		<html>
			<head/>
			<body>
-->
		<xsl:for-each select="QdmProject">
		<xsl:text>,Description,Units,,Total Estimated Quantity,</xsl:text>
		<xsl:for-each select="Phases/Phase">
				<xsl:for-each select="Name">
					<xsl:variable name="phaseName" select="."/>
					<xsl:if test="count(//Payitem[@phase=$phaseName]) &gt; 0">
					<xsl:text>"</xsl:text>
					<xsl:apply-templates/>
					<xsl:text>",</xsl:text>
					</xsl:if>
					
				</xsl:for-each>
			</xsl:for-each>,
<xsl:for-each select= "Payitem[count(.|key('payitem-name-key',Name)[1])=1]">
<xsl:sort select="Name" data-type="text"/>
				<xsl:variable name="payitemName">
					<xsl:value-of select="Name"/>
				</xsl:variable>
				<xsl:value-of select="Name"/>,"<xsl:call-template name="duplicate-the-double-quotes">
					<xsl:with-param name="text" select="Description"/>
				</xsl:call-template>",<xsl:value-of select="Unit"/>,,<xsl:value-of select="sum(//Payitem[Name=$payitemName]/TotalQuantity)"/>,<xsl:for-each select="../Phases/Phase">
					<xsl:variable name="phaseName">
						<xsl:value-of select="Name"/>
					</xsl:variable>
					<xsl:if test="count(//Payitem[@phase=$phaseName]) &gt; 0">
						<xsl:for-each select="../../Payitem[@phase=$phaseName]">
							<xsl:if test="Name=$payitemName">
								<xsl:value-of select="TotalQuantity"/>
							</xsl:if>
						</xsl:for-each>
						<xsl:text>,</xsl:text>
					</xsl:if>
					</xsl:for-each>,
</xsl:for-each>
		</xsl:for-each>
	</xsl:template>
	<!--template to replace the double quotes with two double quotes. -->
	<xsl:template name="duplicate-the-double-quotes">
		<xsl:param name="text"/>
		<xsl:variable name="replace">"</xsl:variable>
		<xsl:choose>
			<xsl:when test="contains($text, $replace)">
				<xsl:value-of select="substring-before($text, $replace)"/>
				<xsl:text disable-output-escaping="no">""</xsl:text>
				<xsl:call-template name="duplicate-the-double-quotes">
					<xsl:with-param name="text" select="substring-after($text, $replace)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
