<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema">
	<xsl:template match="/">
		<!--		<html>
			<head/>
			<body>
-->
		<xsl:for-each select="QdmProject">ITEM NO.,DESCRIPTION,UNITS,TOTAL ESTIMATED QUANTITIES,,<xsl:for-each select="Fundings/Funding">
				<xsl:for-each select="Name">"<xsl:apply-templates/>",</xsl:for-each>
			</xsl:for-each>
,,,,,<xsl:for-each select="Fundings/Funding">"<xsl:call-template name="duplicate-the-double-quotes"><xsl:with-param name="text" select="Description"/></xsl:call-template>",</xsl:for-each>,
<xsl:for-each select="Payitem">
				<xsl:variable name="payitemName">
					<xsl:value-of select="Name"/>
				</xsl:variable>
				<xsl:value-of select="Name"/>,"<xsl:call-template name="duplicate-the-double-quotes">
      <xsl:with-param name="text" select="Description"/>
     </xsl:call-template>",<xsl:value-of select="Unit"/>,<xsl:value-of select="TotalQuantity"/>,,<xsl:for-each select="../Fundings/Funding">
					<xsl:variable name="fundingName">
						<xsl:value-of select="Name"/>
					</xsl:variable>
					<xsl:for-each select="../../Payitem/Funding">
						<xsl:if test="../Name=$payitemName">
							<xsl:if test="Name=$fundingName">
								<xsl:value-of select="Quantity"/>
							</xsl:if>
						</xsl:if>
					</xsl:for-each>,</xsl:for-each>,
</xsl:for-each>
		</xsl:for-each>
	</xsl:template>
	
	<!--template to replace the double quotes with two double quotes. -->
	<xsl:template name="duplicate-the-double-quotes">
		<xsl:param name="text"/>
		<xsl:variable name="replace">"</xsl:variable>
		<xsl:choose>
			<xsl:when test="contains($text, $replace)">
				<xsl:value-of select="substring-before($text, $replace)"/>
				<xsl:text disable-output-escaping="no">""</xsl:text>
				<xsl:call-template name="duplicate-the-double-quotes">
					<xsl:with-param name="text" select="substring-after($text, $replace)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
